## RiskyMod
A full-game overhaul that aims to bring it closer to RoR1's balance. My main priority is multiplayer, but the mod is balanced in solo as well. Nearly every change from this mod can be toggled on/off, so you can configure it to your liking!

I highly recommed installing https://thunderstore.io/package/Moffein/EliteReworks/ to go with this.

Full change list can be found at https://docs.google.com/document/d/1Igxdur0M33fdkcDLYgDEbLE0M4-89gSTorxgdn-oyKs/

This mod merges in fixes and tweaks from a bunch of other mods. If you have those mods installed, these fixes/changes will disable and the original mod will take priority.

Feel free to take features of this mod and release them as standalone as long as you link the original GitHub repo in the README.

**Contact me if you're interested in translating the mod!**

## Main Features

- Oneshot Protection now actually works.
	- Oneshot = Going from >90% HP to 0% HP in under 0.5s
	- Once triggered, you have to be out of danger (no damage for 7s) before it can be retriggered.
- Shields gate against HP damage like the Guardian's Heart in RoR1.
- Big balance pass over nearly all the items.
	- Bad items like Squid Polyps and Warbanners have gotten substantial buffs.
	- Strong damage items like AtGs and Elemental Bands now have lowered damage stacking.
	- Most forms of range scaling have been removed, and most items aren't able to proc chain anymore.
- Big balance pass over all the Survivors
	- Less useless skill options, default Commando is good now!
- Drone performance now remains the same on all stages.

## Other Changes

- Combat Shrines give less money, but drop items for the team on completion.
- Teleporter radius expands once the boss is dead.
- Tweaked Commencement
	- Only 2 pillars are required to activate the jump pads.
	- Pillars drop items for the team on completion, and you can complete as many as you want.

## Installation
Place RiskyMod.dll **AND** the **language folder** in /Risk of Rain 2/BepInEx/plugins/RiskyMod

## Planned Changes (Not implemented yet)

- Make Google Doc more readable/pretty.
	- Split up into multiple separate docs?

*Mostly done with everything I've wanted to do with the mod. Plan going forward is to iron out the existing balance. There's some items that I don't like but don't have any ideas for reworking, so I'll list them here and leave it up to you on whether you want to enable them in your runs.*

- Items I don't like but don't want to touch either:
	- Roll of Pennies
	- Lost Seer's Lens 
	- Regenerating Scrap
	- Executive Card
	
## For Developers

To make custom allies compatible with RiskyMod's ally changes, use these items located in AllyItems.cs:

- AllyMarkerItem makes the holder benefit from Ally damage resistances. No effect when stacked.
- AllyScalingItem changes level scaling from +30% HP +20% damage -> +20% HP +30% damage so that allies perform the same on all stages. No effect when stacked.
- AllyRegenItem makes the holder's HP regenerate to full in X seconds, X being the amount of stacks.
- AllyAllowVoidDeathItem makes the holder to bypass the "No Void Death" config option.
- AllyAllowOverheatDeathItem makes the holder to bypass the "No Overheat" config option.
- AllyResistAoEItem enables the ResistantToAoE bodyflag on the holder, granting them +300 armor against attacks with DamageType.AoE

These are always initialized even if Ally changes are disabled and their effects have config-checking built-in, so you can simply add them to your allies without having to worry about anything.

Make sure these are only given to Player-team allies, since they'll be painful to fight against (in a bad/unintuitive way) when they're given to enemies.
	
## Credits

Drone Targeting fix - ZetTweaks

Squid Polyp Distraction - DestroyedClone

Language Support - Anreol

Skill Icons - KoobyKarasu

Acrid Hitbox Tweaks - TheTimesweeper

Buff Icons - SOM, VALE-X

## Changelog

*Full changelog included in the .zip*

`0.17.4`

- Allies
	- Now take reduced damage from Mithrix's ground shockwave.
	- Added extra code to make sure Internal Ally Items only give benefits when on the player team.
		- ImmuneToVoidDeath/ImmuneToOverheat are exempt from this, but these are too niche to matter much.
	
- Gunner Turret
	- Now teleports to your location when starting the Mithrix fight.
	- Increased targeting range from 60 -> 120

`0.17.3`

- Ally Regen modifiers are now calculated after all HP changes.
	- Modifier has been moved to the end of RecalculateStats. This allows it to work with DroneMeld's HP scaling.
	
- Gunner Turrets are now repairable.

- Reduced default max Shrine of Combats per stage from 5 -> 3

	*Having too many of these on a single stage causes it to be a hassle for everyone to have to scramble across the entire stage to figure out which shrines they missed.*
	
`0.17.2`

- Added extra nullchecking to Lepton Daisy and TeleExpandOnBossKill.

`0.17.1`

- Changed default Mountain/Combat shrine limit back to 5.

`0.17.0`

- Interactables
	- Shrine of the Mountain
		- Changed default limit from 5 -> -1 (Unlimited)
		- Re-enabled director cost scaling with playercount (+0.5x per player).
		
	- Shrine of Combat
		- Changed default limit from 5 -> -1 (Unlimited)
		- Re-enabled director cost scaling with playercount (+0.5x per player).
		
	*Scaling director credit cost got broken by SotV, but I figured out a fix for it.*

- Allies
	- TC280
		- Deathstate now supports DroneMeld.

- Character Mechanics
	- Nullify Debuff
		- Now only takes 2 stacks to root.
			- Disabled if EliteReworks is installed since the same change is added there.
			- This allows Void Reavers to root players in a single hit.
				- Leaving this on to see how it performs, since Reavers have always been pretty useless outside of their death explosion and Jailers already have access to a guaranteed root attack that's easier to land than this.
	
- Items
	- Squid Polyp
		- Distraction no longer works on Champion (boss) enemies.
		
	- Defense Nucleus
		- Alpha Constructs now distract non-Champion (non-boss) enemies.
		
- Survivors
	- MUL-T
		- Scrap Launcher blast damage falloff reduced from -75% -> -50%

- Enemies
	- Parent
		- Reduced attack damage falloff from -75% -> -50%

	- Mithrix
		- Now tries to prioritize attacking human players if possible.
			- Does not apply to Phase 4.
		
		*With allies being a lot more durable, Mithrix often got stuck fighting them instead of acutal players.*
			
	- Voidling
		- Now tries to prioritize attacking human players if possible.
		- Reduced HP from 2000 -> 1400 (100% -> 40% tankier than Mithrix)
		- Void Fog now uses the same numbers as the Void Fields.
		
		*Just bare minimum changes to make it slightly more tolerable to fight.*

- Spawnpool Changs are now out of beta and are enabled by default. No longer relies on DirectorAPI.
	- Titanic Plains
		- Removed Alpha/Xi Constructs.
		- Removed Jellyfish.
		- Added Bisons when looping.
		
	- Distant Roost
		- Removed Lesser Wisps.
		- Jellyfish now spawn pre-loop.
		- Added Alpha Constructs when looping.
		
	- Siphoned Forest
		- Removed Beetles.
		- Removed Lesser Wisps.
		- Blind Vermin now spawn pre-loop.
		- Added Bisons when looping.
		
	- Abandoned Aqueduct
		- Clay Apothecaries now spawn pre-loop.
		
	- Siren's Call
		- Added Overloading Worms.
		
	- Sundered Grove
		- Removed Lemurians.
		- Removed Clay Dunestrider.
		- Reduced Mushrum spawnrate.
		- Added Alloy Vultures.
		- Added Grovetender.
		
	- Sky Meadow
		- Removed Alpha/Xi Constructs.
		- Removed Wisps.
		- Removed Mushrums.
		- Removed Bronzongs.
		- Added Jellyfish.
		- Added Imps.
		- Added Lunar Golems.
			- HP is scaled to be the same as Elder Lemurians.